//: C11:Incrementer.cpp {RunByHand}
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
// Zrušení objektů v době, kdy vlákno ještě 
// běží způsobí vážné problémy.
//{L} ZThread
#include <iostream>
#include "zthread/Thread.h"
#include "zthread/ThreadedExecutor.h"
using namespace ZThread;
using namespace std;

class Pocet {
  enum { SZ = 100 };
  int n[SZ];
public:
  void inkrementovat() {
    for(int i = 0; i < SZ; i++)
      n[i]++;
  }
};

class Prirustky : public Runnable {
  Pocet* pocet;
public:
  Prirustky(Pocet* c) : pocet(c) {}
  void run() {
    for(int n = 100; n > 0; n--) {
      Thread::sleep(250);
      pocet->inkrementovat();
    }
  }
};

int main() {
  cout << "Toto způsobí selhání členění!" << endl;
  Pocet pocet;
  try {
    Thread t0(new Prirustky(&pocet));
    Thread t1(new Prirustky(&pocet));
  } catch(Synchronization_Exception& e) {
    cerr << e.what() << endl;
  }
} ///:~
